CREATE OR REPLACE PROCEDURE pStatutCommande 
(leNoCommande	Commande.noCommande%TYPE ) IS

	-- Dclaration de variables
leNoClient			Client.noClient%TYPE;
	laDateCommande		Commande.dateCommande%TYPE ;
	leNoArticle			Article.noArticle%TYPE ;
laQuantitCommande	LigneCommande.quantit%TYPE ;
laQuantitLivre		INTEGER;
laQuantitEnAttente	INTEGER;

	-- Dclaration d'un curseur (CURSOR) PL/SQL pour itrer sur les lignes
	-- de la commande
	CURSOR lignesCommande(unNoCommande Commande.noCommande%TYPE)IS
    		SELECT 	noArticle, quantit
    		FROM		LigneCommande
    		WHERE 		LigneCommande.noCommande = unNoCommande ;

BEGIN
DBMS_OUTPUT.PUT_LINE('Commande #:'||TO_CHAR(leNoCommande));

	SELECT		noClient, dateCommande
	INTO		leNoClient, laDateCommande
	FROM		Commande
WHERE		noCommande = leNoCommande;

DBMS_OUTPUT.PUT_LINE('noClient:'||TO_CHAR(leNoClient));
DBMS_OUTPUT.PUT_LINE('dateCommande:'||TO_CHAR(laDateCommande));

	OPEN lignesCommande(leNoCommande);
	-- Le OPEN ouvre le CURSOR en lui passant les paramtres

	LOOP
		FETCH lignesCommande INTO leNoArticle, laQuantitCommande;
		-- Le FETCH retourne la ligne suivante

		EXIT WHEN lignesCommande%NOTFOUND;
		-- %NOTFOUND est un attribut du CURSOR qui permet de dterminer
		-- si le FETCH a atteint la fin de la table 

		DBMS_OUTPUT.PUT('noArticle :');
		DBMS_OUTPUT.PUT(leNoArticle);
		DBMS_OUTPUT.PUT(' quantit commande:');
		DBMS_OUTPUT.PUT(laQuantitCommande);

		-- Chercher la quantit dj livre
		SELECT		SUM(quantitLivre)
		INTO		laQuantitLivre
		FROM		DtailLivraison
		WHERE 		noArticle = leNoArticle AND
				noCommande = leNoCommande ;

		IF (laQuantitLivre IS NULL) THEN
			DBMS_OUTPUT.PUT_LINE(' livraison en attente');
		ELSE
			laQuantitEnAttente:= laQuantitCommande -laQuantitLivre;
			IF (laQuantitEnAttente = 0) THEN
				DBMS_OUTPUT.PUT_LINE(' livraison complte');
			ELSE
				DBMS_OUTPUT.PUT (' quantit en attente :');
				DBMS_OUTPUT.PUT_LINE(laQuantitEnAttente);
			END IF ;
		END IF ;
	END LOOP;

	-- Le CLOSE ferme le CURSOR
	CLOSE lignesCommande;

EXCEPTION
	WHEN NO_DATA_FOUND THEN
		DBMS_OUTPUT.PUT_LINE('Numro de commande inexistant');
	WHEN	OTHERS THEN
		RAISE_APPLICATION_ERROR(-20001,'Exception leve par la procdure');
END pStatutCommande;
/
SET SERVEROUTPUT ON
/
EXECUTE pStatutCommande(2)
/
CREATE OR REPLACE PROCEDURE pStatutCommande 
(leNoCommande	Commande.noCommande%TYPE ) IS

	-- Dclaration de variables
leNoClient			Client.noClient%TYPE;
	laDateCommande		Commande.dateCommande%TYPE ;
laQuantitLivre		INTEGER;
laQuantitEnAttente	INTEGER;

	-- Dclaration d'un curseur (CURSOR) PL/SQL pour itrer sur les lignes
	-- de la commande
	CURSOR lignesCommande(unNoCommande Commande.noCommande%TYPE)IS
    		SELECT 	noArticle, quantit
    		FROM		LigneCommande
    		WHERE 		LigneCommande.noCommande = unNoCommande ;

BEGIN
DBMS_OUTPUT.PUT_LINE('Commande #:'||TO_CHAR(leNoCommande));

	SELECT		noClient, dateCommande
	INTO		leNoClient, laDateCommande
	FROM		Commande
WHERE		noCommande = leNoCommande;

DBMS_OUTPUT.PUT_LINE('noClient:'||TO_CHAR(leNoClient));
DBMS_OUTPUT.PUT_LINE('dateCommande:'||TO_CHAR(laDateCommande));

	FOR uneLigne IN lignesCommande(leNoCommande) LOOP

		DBMS_OUTPUT.PUT('noArticle :');
		DBMS_OUTPUT.PUT(uneLigne.noArticle);
		DBMS_OUTPUT.PUT(' quantit commande:');
		DBMS_OUTPUT.PUT(uneLigne.quantit);

		-- Chercher la quantit dj livre
		SELECT		SUM(quantitLivre)
		INTO		laQuantitLivre
		FROM		DtailLivraison
		WHERE 		noArticle = uneLigne.noArticle AND
				noCommande = leNoCommande ;

		IF (laQuantitLivre IS NULL) THEN
			DBMS_OUTPUT.PUT_LINE(' livraison en attente');
		ELSE
			laQuantitEnAttente:= uneLigne.quantit -laQuantitLivre;
			IF (laQuantitEnAttente = 0) THEN
				DBMS_OUTPUT.PUT_LINE(' livraison complte');
			ELSE
				DBMS_OUTPUT.PUT (' quantit en attente :');
				DBMS_OUTPUT.PUT_LINE(laQuantitEnAttente);
			END IF ;
		END IF ;
	END LOOP;

EXCEPTION
	WHEN NO_DATA_FOUND THEN
		DBMS_OUTPUT.PUT_LINE('Numro de commande inexistant');
	WHEN	OTHERS THEN
		RAISE_APPLICATION_ERROR(-20001,'Exception leve par la procdure');
END pStatutCommande;
/
CREATE OR REPLACE FUNCTION fQuantitEnStock
(unNoArticle 	Article.noArticle%TYPE)
RETURN Article.quantitEnStock%TYPE IS

 	uneQuantitEnStock 	Article.quantitEnStock%TYPE;
BEGIN
	SELECT 	quantitEnStock
	INTO 		uneQuantitEnStock
	FROM 		Article
	WHERE 		noArticle = unNoArticle; 
	RETURN uneQuantitEnStock;
END fQuantitEnStock;
/
select fQuantitEnStock(10) from dual
/
CREATE OR REPLACE PROCEDURE pModifierQuantitEnStock
(unNoArticle 			Article.noArticle%TYPE, 
 nouvelleQuantitEnStock 		Article.quantitEnStock%TYPE) IS
BEGIN
 	UPDATE		Article
 	SET		quantitEnStock = nouvelleQuantitEnStock
 	WHERE		noArticle = unNoArticle;
END pModifierQuantitEnStock;
/
EXECUTE pModifierQuantitEnStock(10,20)
/
SELECT * FROM Article WHERE noArticle = 10
/
SELECT text
FROM   USER_SOURCE
WHERE  name = 'FQUANTITENSTOCK' AND type = 'FUNCTION'
ORDER BY  line
/

